#Window_1 = 0
#Button_1 = 0

#max = 64   ; #max iterations 

#x1 = 300    ; ScreenX 
#y1 = 200    ; ScreenY 




Procedure HSB2RGB(hue.f, saturation.f, brightness.f) 
  If brightness = 0 
    ProcedureReturn 0 
  EndIf 
  If saturation = 0 
    ProcedureReturn RGB(brightness*255, brightness*255, brightness*255) 
  EndIf 
  red.f : green.f : blue.f : domainOffset.f
  If hue < 1.0/6 
    ; red domain; green ascends 
    domainOffset = hue 
    red   = brightness 
    blue  = brightness * (1.0 - saturation) 
    green = blue + (brightness - blue) * domainOffset * 6 
  ElseIf hue < 2.0/6 
    ; yellow domain; red descends 
    domainOffset = hue - 1.0/6 
    green = brightness 
    blue  = brightness * (1.0 - saturation) 
    red   = green - (brightness - blue) * domainOffset * 6 
  ElseIf hue < 3.0/6 
    ; green domain; blue ascends 
    domainOffset = hue - 2.0/6 
    green = brightness 
    red   = brightness * (1.0 - saturation) 
    blue  = red + (brightness - red) * domainOffset * 6 
  ElseIf hue < 4.0/6 
    ; cyan domain; green descends 
    domainOffset = hue - 3.0/6 
    blue  = brightness 
    red   = brightness * (1.0 - saturation) 
    green = blue - (brightness - red) * domainOffset * 6 
  ElseIf hue < 5.0/6 
    ; blue domain; red ascends 
    domainOffset = hue - 4.0/6 
    blue  = brightness 
    green = brightness * (1.0 - saturation) 
    red   = green + (brightness - green) * domainOffset * 6 
  Else 
    ; magenta domain; blue descends 
    domainOffset = hue - 5.0/6 
    red   = brightness 
    green = brightness * (1.0 - saturation) 
    blue  = red - (brightness - green) * domainOffset * 6 
  EndIf 
  ProcedureReturn RGB(red * 255, green * 255, blue * 255) 
EndProcedure 


; Procedure HSB2RGB(hue.f) 
;    ProcedureReturn RGB(hue*255, 0, 0) 
; EndProcedure

Procedure.f DotsColor(xval.f, yval.f) ; color value from 0.0 to 1.0 by iterations 
  I.f : m.f : r.f : j.f 
  While (j < #max) And (m < 4.0) 
    j=j+1 
     m = r * r - i * i 
    i = 2.0 * r * i + yval 
    r = m + xval 
  Wend 
  ProcedureReturn j / #max 
EndProcedure 

Procedure mandelbrot(xstart.f, ystart.f, xzoom.f, yzoom.f) ; calculate all points 
  h.f : old.f 
;   For x = 0 To #x1 - 1 
;     For y = 0 To #y1 - 1 
  For y = 0 To #y1 - 1 
    For x = 0 To #x1 - 1 
      h = DotsColor(xstart + (xzoom * x), ystart + (yzoom * y)) ; color value 

      If h <> old 
        b = 1.0 - h * h ; brightness 
        col = HSB2RGB(h , 0.8, b) 
        old = h; 
      EndIf 

;       If h <> old 
;         col = HSB2RGB(h) 
;         old = h; 
;       EndIf 
      
      Plot(x, y, col)
    Next 
  Next 
EndProcedure 


If OpenWindow(#Window_1, 200, 200, 301, 201, "",  #PB_Window_SystemMenu | #PB_Window_TitleBar )
ButtonGadget(#Button_1, 5, 5, 25, 25, "Go")


  Repeat 
    event = WaitWindowEvent() 
    Select event 
    Case #PB_Event_Gadget 
      Select EventGadget() 
        Case #Button_1
        
          xstart.f = -2.025   :  ystart.f = -1.125         
          xende.f = 0.6       :  yende.f = 1.125 
        
          xzoom.f = (xende - xstart) / #x1 
          yzoom.f = (yende - ystart) / #y1 

          fac.f = 0.99 
                    
          xende = xende * fac 
          xstart = xstart * fac 
          ystart = ystart * fac 
          yende = yende * fac 
          xzoom = (xende - xstart) / #x1 
          yzoom = (yende - ystart) / #y1 
          timer = GetTickCount_()
           
          StartDrawing(WindowOutput(#Window_1)) 
          mandelbrot(xstart.f, ystart.f, xzoom.f, yzoom.f) 
          timer = GetTickCount_() - timer 
          speed = Int(#x1*#y1 / (1+(timer)))
          SetWindowTitle(#Window_1, "Speed: " + Str(speed) + " Kpix/sec") 
          StopDrawing()
   
      EndSelect 
    EndSelect 
  Until event = #PB_Event_CloseWindow 

EndIf
; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableXP
; Executable = Mandelbrot_test1.exe
; DisableDebugger